//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "music.h"
#include "console.h"

static int musicStarted=0;
static int musicMute=0;

static int request=0;
static GroupFile *reqGroup;
static char reqName[256];
static HWND hWnd;

void RequestMusic(GroupFile *group,char *name)
{
    if (group->FileSize(name)==-1)
        throw "Music file does not exist\n";
    reqGroup=group;
    strcpy(reqName,name);
    request=1;
}

void ProcessMusicRequest(HWND _hWnd)
{
    if (!request) return;
    hWnd=_hWnd;
    request=0;
    if (musicStarted)
        StopMusic();
    char *buf=new char[reqGroup->FileSize(reqName)];
    reqGroup->LoadFile(reqName,buf);
    FILE *fp=fopen("tempmidi.~~~","wb");
    fwrite(buf,1,reqGroup->FileSize(reqName),fp);
    fclose(fp);
    cprintf("Loaded music %s\n",reqName);
    if (!musicMute)
    {
	    char strRet[256];
    	mciSendString("open sequencer!tempmidi.~~~ alias duke",strRet,256,NULL);
	    mciSendString("play duke notify",strRet,256,hWnd);
        cprintf("Started music %s\n",reqName);
    }
    musicStarted=1;
}

void StopMusic()
{
    if (!musicStarted)
        return;
    musicStarted=0;
    if (!musicMute)
    {
    	char strRet[256];
	    mciSendString("close duke",strRet,256,NULL);
        cprintf("Music stopped\n");
    }
    remove("tempmidi.~~~");
}
//---------------------------------------------------------------------------

int IsMusicPlaying()
{
    return musicStarted;
}

void MusicMute(int mute)
{
    musicMute=mute;
    if (musicMute)
    {
        if (musicStarted)
        {
    	    char strRet[256];
	        mciSendString("close duke",strRet,256,NULL);
            cprintf("Music stopped\n");
        }
    }
    else
    {
        if (musicStarted)
        {
    	    char strRet[256];
    	    mciSendString("open sequencer!tempmidi.~~~ alias duke",strRet,256,NULL);
	        mciSendString("play duke notify",strRet,256,hWnd);
        }
    }
}

#pragma package(smart_init)
